﻿
assert(oRA, "oRA not found!")

------------------------------
--      Are you local?      --
------------------------------

local L = AceLibrary("AceLocale-2.2"):new("oRAOptions")
local Tablet = AceLibrary("Tablet-2.0")

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	tablethint = "|cffeda55fCtrl-Alt-Click|r to disable oRA completely.",
	tablethint_disabled = "oRA is currently disabled. |cffeda55fClick|r to enable.",
	["oRA Options"] = true,
	["Active boss modules"] = true,
	["Hidden"] = true,
	["Shown"] = true,
	["minimap"] = true,
	["Minimap"] = true,
	["Toggle the minimap button."] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	tablethint = "|cffeda55fCtrl Alt 클릭시|r oRA를 완전히 사용하지 않습니다.",
	tablethint_disabled = "oRA 는 현재 사용중지 중입니다. |cffeda55f클릭시|r 사용합니다.",
	["oRA Options"] = "oRA 설정",
	["Active boss modules"] = "보스 모듈 활성화",
	["Hidden"] = "숨김",
	["Shown"] = "표시",
	["Minimap"] = "미니맵",
	["Toggle the minimap button."] = "미니맵 버튼 토글",
} end)


L:RegisterTranslations("zhCN", function() return {
	tablethint = "oRA 选项",
	["Active boss modules"] = "激活boss模块",
	["Hidden"] = "隐藏",
	["Shown"] = "显示",
	["minimap"] = "小地图",
	["Minimap"] = "小地图",
	["Toggle the minimap button."] = "显示小地图图标",
} end)

L:RegisterTranslations("zhTW", function() return {
	tablethint = "oRA 選項",
	["Active boss modules"] = "啟動BOSS模組",
	["Hidden"] = "隱藏",
	["Shown"] = "顯示",
	["minimap"] = "小地圖",
	["Minimap"] = "小地圖",
	["Toggle the minimap button."] = "顯示小地圖按鈕",
} end)

----------------------------------
--      Module Declaration      --
----------------------------------

local deuce = oRA:NewModule("Options Menu")
deuce.hasFuBar = IsAddOnLoaded("FuBar") and FuBar
deuce.consoleCmd = not deuce.hasFuBar and L["minimap"]
deuce.consoleOptions = not deuce.hasFuBar and {
	type = "toggle",
	name = L["Minimap"],
	desc = L["Toggle the minimap button."],
	get = function() return oRAOptions.minimapFrame and oRAOptions.minimapFrame:IsVisible() or false end,
	set = function(v) if v then oRAOptions:Show() else oRAOptions:Hide() end end,
	map = {[false] = L["Hidden"], [true] = L["Shown"]},
	hidden = function() return deuce.hasFuBar and true end,
}

----------------------------
--      FuBar Plugin      --
----------------------------

oRAOptions = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0")
oRAOptions.name = "FuBar - oRA"
oRAOptions:RegisterDB("oRAFubarDB")

oRAOptions.hasNoColor = true
oRAOptions.hasIcon = "Interface\\AddOns\\oRA2\\Icons\\core_enabled"
oRAOptions.defaultMinimapPosition = 180
oRAOptions.hideWithoutStandby = true
oRAOptions.clickableTooltip = true

-- XXX total hack
oRAOptions.OnMenuRequest = deuce.core.consoleOptions
local args = AceLibrary("FuBarPlugin-2.0"):GetAceOptionsDataTable(oRAOptions)
for k,v in pairs(args) do
	if oRAOptions.OnMenuRequest.args[k] == nil then
		oRAOptions.OnMenuRequest.args[k] = v
	end
end
-- XXX end hack

-----------------------------
--      Icon Handling      --
-----------------------------

function oRAOptions:OnEnable()
	self:RegisterEvent("oRA_CoreEnabled", "CoreState")
	self:RegisterEvent("oRA_CoreDisabled", "CoreState")
	self:RegisterEvent("oRA_UpdateConfigGUI", "Update")

	self:CoreState()
end

function oRAOptions:CoreState()
	if oRA:IsActive() then
		self:SetIcon("Interface\\AddOns\\oRA2\\Icons\\core_enabled")
	else
		self:SetIcon("Interface\\AddOns\\oRA2\\Icons\\core_disabled")
	end

	self:UpdateTooltip()
end

-----------------------------
--      FuBar Methods      --
-----------------------------

function oRAOptions:OnTooltipUpdate()
--	local cat = Tablet:AddCategory("columns", 1)
--	cat:AddLine("text", L["oRA Options"], "justify", "CENTER")
	if oRA:IsActive() then
		Tablet:SetHint(L["tablethint"])
		for k,module in pairs(oRA.moduletooltips) do
			module:OnTooltipUpdate()
		end
	else
		Tablet:SetHint(L["tablethint_disabled"])
	end
end

function oRAOptions:OnClick()
	if oRA:IsActive() then
		if IsControlKeyDown() and IsAltKeyDown() then
			oRA:ToggleActive(false)
		end
	else
		oRA:ToggleActive(true)
	end

	self:UpdateTooltip()
end

